clear; close all;

load('Full20objDatanobadshapes.mat')

%% Shape geodesic examples between two randomly selected objects
rng(10010101)

p1=C(:,:,ceil(rand*1300));
p2=C(:,:,ceil(rand*1300));

d = GeodesicElasticClosed(p1,p2);
d

%% Mean, Covariance and Sampling Example 1
Data=C(:,:,1225:1229);

% Display the data
stp=.5;
figure(20),clf,hold on
for j=1:size(Data,3)
    X = ReSampleCurve(Data(:,:,j),100);
    q = curve_to_q(X);
    Data(:,:,j)=q_to_curve(q);
    plot(Data(1,:,j)+stp*(j-1),Data(2,:,j),'LineWidth',2)
end
axis equal off

%Compute the mean
[mu,q,dE] = FindElasticMean(Data);

%Compute the covariance and PCA
U=FindElasticCovariance(mu,q);

%% Mean, Covariance and Sampling Example 2
Data=C(:,:,965:969);

% Display the data
stp=.5;
figure(20),clf,hold on
for j=1:size(Data,3)
    X = ReSampleCurve(Data(:,:,j),100);
    q = curve_to_q(X);
    Data(:,:,j)=q_to_curve(q);
    plot(Data(1,:,j)+stp*(j-1),Data(2,:,j),'LineWidth',2)
end
axis equal off

%Compute the mean
[mu,q,dE] = FindElasticMean(Data);

%Compute the covariance and PCA
U=FindElasticCovariance(mu,q);

%% Mean, Covariance and Sampling Example 3
Data=C(:,:,865:869);

% Display the data
stp=.5;
figure(20),clf,hold on
for j=1:size(Data,3)
    X = ReSampleCurve(Data(:,:,j),100);
    q = curve_to_q(X);
    Data(:,:,j)=q_to_curve(q);
    plot(Data(1,:,j)+stp*(j-1),Data(2,:,j),'LineWidth',2)
end
axis equal off

%Compute the mean
[mu,q,dE] = FindElasticMean(Data);

%Compute the covariance and PCA
U=FindElasticCovariance(mu,q);